{{- $pullUsingCredentials := (and .Values.gateway.image.credentials.username .Values.gateway.image.credentials.password .Values.gateway.image.credentials.registry .Values.gateway.image.credentials.email) -}}

# This creates the content of the .dockerconfig file (json content) & encodes it in base64
{{- define "imagePullSecret" }}
  {{- with .Values.gateway.image.credentials }}
    {{- printf "{\"auths\":{\"%s\":{\"username\":\"%s\",\"password\":\"%s\",\"email\":\"%s\",\"auth\":\"%s\"}}}" .registry .username .password .email (printf "%s:%s" .username .password | b64enc) | b64enc }}
  {{- end }}
{{- end }}

{{ if $pullUsingCredentials }}
apiVersion: v1
kind: Secret
metadata:
  name: docker-registry-credentials
  annotations:
    {{- range $key, $value := .Values.gateway.annotations }}
    {{ $key }}: {{ $value | quote }}
    {{- end }}
type: kubernetes.io/dockerconfigjson
data:
  .dockerconfigjson: {{ template "imagePullSecret" . }}
{{ end }}